/*
 *  GLFfromVCF.h
 *  LocalAncestry
 *
 *  Created by Youna Hu on 4/1/11.
 *  Copyright 2011 U of Michigan. All rights reserved.
 *
 */
#ifndef __VCF_to_GLF__
#define __VCF_to_GLF__
#include <vector>
#include "StringBasics.h"
#include "StringMap.h"
#include "StringArray.h"
#include "Error.h"
#include <iostream>
#include <math.h>
#include "RefPplns.h"
#include "MathMatrix.h"
#include <utility>

// This function reads one subjects from the vcf and extract the genotye likelihood
class GLFfromVCF{
private:
	int colChr,colPos,colRef,colAlt,colInd,colFormat,splitGL;
	String GLLKkey;
	// In this design, we assume that there is no error in 
	std::vector< long > variantID;
	std::vector< char > refA;
	std::vector< char > altA;
public:
	String idSubj2Decomp;
	int nOverlap;
	int T; // number of generation since admixture
	int numStatesOneChain, numChains, numStates;
	std::vector< std::vector<double> > gllk; // GLs for 0|0,0|1,1|1 cases
	std::vector<double> altFrq;
	std::vector< long > overlapVariantID;
	std::vector< std::vector<double> > overlapGLs; // scale of 1  (0 -1) instead of phred scale
	std::vector< std::vector<double> > overlapAFs;
	// For now, the recombination map is really crude, 
	// need either to refine it or to estimate it later
	std::vector< double > overlapGDist; 
	Matrix e; // 
	// t - transition probability, not uniform due to different recombination rate
	std::vector< Matrix > t; //It looks like this cannot be done either 
	// I wonder if I should store all the transition matrix or 
	
public:
	GLFfromVCF(String &inFile, String gllkKey, int subjColumn = 9, int Time = 4);
	void UpdateGLFs(String &inFile);
	void UpdateGenoFreqs(String & inFile1, String & inFile2, String & inGDistFile);
	// This outFile stores all the conditional probability of hidden states given observations
	void UpdateEandT(String &outFile); 
};

#endif
